<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  
  <!-- Import DataTable Library -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.13.3/css/jquery.dataTables.min.css">
  <script src="https://cdn.datatables.net/1.13.3/js/jquery.dataTables.min.js"></script>
  
</head>
<body>
<div class="container">
  <div class="text-center mt-2 mb-2">
    <h2>F120 - Quản trị Order</h2>
  </div>
  <div class="jumbotron container">
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="voucherCodeInput">Loại Pizza</label>
      </div>
      <div class="col-sm-6">
        <select id="gPizzaTypeSelect" class="form-control">

        </select>
      </div>
      <div class="col-sm-3">
        <button id="btn-filter-order" class="btn btn-info">Lọc dữ liệu</button>
      </div>
    </div>
</div>

<div class="container">
  <table class="table table-bordered table-striped table-hover" id="order-table">
    <thead>
      <tr>
        <th>STT</th>
        <th>Mã order</th>
        <th>Loại Pizza</th>
        <th>Tên khách hàng</th>
        <th>Ngày đặt hàng</th>
        <th>Trạng thái</th>
        <th>Action</th>
      </tr>
    </thead>
  </table>
</div>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // mảng orders
  var gOrderObjects = [
      {
          "id": 2,
          "orderCode": "12456",
          "gPizzaTypeId": 20,
          "customerName": "Do Van Linh",
          "date": "13/01/2021",
          "status": "completed"
      },
      {
          "id": 3,
          "orderCode": "22456",
          "gPizzaTypeId": 10,
          "customerName": "Huynh Van Nam",
          "date": "13/01/2021",
          "status": "new"
      },
      {
          "id": 4,
          "orderCode": "22986",
          "gPizzaTypeId": 15,
          "customerName": "Do Thi Lan",
          "date": "14/01/2021",
          "status": "completed"
      },
      {
          "id": 5,
          "orderCode": "42086",
          "gPizzaTypeId": 10,
          "customerName": "Dinh Chau Ngoc",
          "date": "14/01/2021",
          "status": "completed"
      },
      {
          "id": 6,
          "orderCode": "56086",
          "gPizzaTypeId": 15,
          "customerName": "Dang Tien Minh",
          "date": "15/01/2021",
          "status": "new"
      },
      {
          "id": 7,
          "orderCode": "90081",
          "gPizzaTypeId": 20,
          "customerName": "Do Hong Quan",
          "date": "15/01/2021",
          "status": "inprogress"
      },
      {
          "id": 8,
          "orderCode": "67012",
          "gPizzaTypeId": 15,
          "customerName": "Bui Thanh Phuoc",
          "date": "15/01/2021",
          "status": "inprogress"
      }
    ];
  
  // mảng pizza Type
  var gPizzaType = [
    {
      typeId: 10,
      typeName: "Hải Sản"
    },
    {
      typeId: 15,
      typeName: "Bò bít tết"
    },
    {
      typeId: 20,
      typeName: "Thịt gà"
    }
  ];

  const ARRAY_NAME_COL = ['id', 'orderCode', 'gPizzaTypeId', 'customerName', 'date', 'status', 'action'];
  const gCOL_ID = 0;
  const gCOL_ID_ORDERCODE = 1;
  const gCOL_PIZZA_ID = 2;
  const gCOL_CUSTOMER_CD = 3;
  const gCOL_DATE = 4;
  const gCOL_STATUS = 5;
  const gCOL_ACTION = 6;
  var gSTT = 1;
  
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  onPageLoading();
  $("#btn-filter-order").on("click", function(){
    onBtnFilterClick();
  });
  
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */ 
  function onPageLoading(){
    "use strict";
    $("#order-table").DataTable({
      data: gOrderObjects,
      columns: [
        {data: ARRAY_NAME_COL[gCOL_ID]},
        {data: ARRAY_NAME_COL[gCOL_ID_ORDERCODE]},
        {data: ARRAY_NAME_COL[gCOL_PIZZA_ID]},
        {data: ARRAY_NAME_COL[gCOL_CUSTOMER_CD]},
        {data: ARRAY_NAME_COL[gCOL_DATE]},
        {data: ARRAY_NAME_COL[gCOL_STATUS]},
        {data: ARRAY_NAME_COL[gCOL_ACTION]},
      ],
      columnDefs: [
        {
          targets: gCOL_ID,
          render: function(data){
            return gSTT++;
          }
        },
        {
          targets: gCOL_ACTION,
          defaultContent:`
            <i title = 'Edit' class="fas fa-edit" style = "cursor:pointer; color:green;"></i> &nbsp; 
            <i title = 'Delete' class="fas fa-trash" style = "cursor:pointer; color:red;"></i>`
        }
      ]
    });

    loadDataToSelect(gPizzaType);
  } 

  //hàm xử lý khi click nút lọc dữ liệu
  function onBtnFilterClick(){
    "use strict";
    //b0: tạo đối tượng chứ dữ liệu lọc
    var vFilter = {
      pizzaTypeID: 0,
    };
    //b1: thu thập dữ liệu lọc
    getDataFromSelect(vFilter);
    //b2: kiểm tra

    //b3: lọc dữ liệu
    var vResultFilter = filterData(vFilter);
    console.log(vResultFilter);

    //b4: hiển thị kết quả lọc 
    displayDataToTable(vResultFilter);
  }
  
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  //hàm hiển thị dữ liệu lọc lên datatable
  //input là dữ liệu cần hiển thị
  function displayDataToTable(paramData){
    "use strict";

    gSTT = 1; //thiết lập lại số thứ tự
    var vTable = $("#order-table").DataTable(); //truy xuất datatable
    vTable.clear(); //xóa dữ liệu của datatable
    vTable.rows.add(paramData); // thêm các dòng dữ liệu và datatable
    vTable.draw();
  }

  //hàm lọc dữ liệu
  //input là điều kiện lọc
  //output là kết quả lọc
  function filterData(paramFilter){
    "use strict";
    var vResult = [];
    vResult = gOrderObjects.filter(function(item){
      return (item.gPizzaTypeId == paramFilter.pizzaTypeID || paramFilter.pizzaTypeID == 0);
    });
    return vResult;
  }

  //hàm thu thập dữ liệu lọc
  //input là đối tượng chứ dữ liệu lọc
  function getDataFromSelect(paramObj){
    "use strict";
    paramObj.pizzaTypeID = $("#gPizzaTypeSelect").val();
  }

  //hàm đổ dữ liệu vào ô select
  //input là dữ liệu cần đồ vào
  function loadDataToSelect(paramData){
    "use strict";
    $("#gPizzaTypeSelect").append($("<option>", {
      value: 0,
      text: "-- Chọn loại Pizza --"
    }));
    for(var bI = 0; bI < paramData.length; bI++){
      $("#gPizzaTypeSelect").append($("<option>", {
      value: paramData[bI].typeId,
      text: paramData[bI].typeName,
    }));
    }
  }

  // hàm trả về pizzaTypeName dựa vào typeId
  function getPizzaNameByTypeId(paramTypeId) {
    "use strict";
    var vPizzaTypeName = "";
    var vIndex = 0;
    var vIsTypeFound = false;
    while(!vIsTypeFound && vIndex < gPizzaType.length) {
      if(gPizzaType[vIndex].typeId === paramTypeId) {
        vIsTypeFound = true;
        vPizzaTypeName = gPizzaType[vIndex].typeName;
      }
      else {
        vIndex ++;
      }
    }
    return vPizzaTypeName;
  }

</script>
</body>
</html>